/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.spi.project.libraries;

import java.net.URL;

/**
 * Abstract location where zero or more libraries are defined.
 * {@link Object#equals} and {@link Object#hashCode} are expected to be defined
 * such that object identity (within the implementing class) are driven by {@link #getLocation}.
 * @see ArealLibraryProvider
 * @since org.netbeans.modules.project.libraries/1 1.15
 */
public interface LibraryStorageArea {

    /**
     * Gets an associated storage location.
     * The contents of the URL (if it is even accessible) are unspecified.
     * @return an associated URL uniquely identifying this location
     */
    URL getLocation();

    /**
     * Gets a human-readable display label for this area.
     * @return a localized display name
     */
    String getDisplayName();

}
