/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2010 Oracle and/or its affiliates. All rights reserved.
 *
 * Oracle and Java are registered trademarks of Oracle and/or its affiliates.
 * Other names may be trademarks of their respective owners.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
/*
 * RelocatePanel.java
 *
 * Created on 03 March 2007, 11:53
 */

package org.netbeans.modules.subversion.ui.relocate;

import javax.swing.JTextField;

/**
 *
 * @author  Peter Pis
 */
public class RelocatePanel extends javax.swing.JPanel {
    
    /** Creates new form RelocatePanel */
    public RelocatePanel() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        tfWorkingCopy = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        tfCurrentURL = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        tfNewURL = new javax.swing.JTextField();

        jLabel1.setLabelFor(tfWorkingCopy);
        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.jLabel1.text")); // NOI18N

        tfWorkingCopy.setEditable(false);

        jLabel2.setLabelFor(tfCurrentURL);
        org.openide.awt.Mnemonics.setLocalizedText(jLabel2, org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.jLabel2.text")); // NOI18N

        tfCurrentURL.setEditable(false);

        jLabel3.setLabelFor(tfNewURL);
        org.openide.awt.Mnemonics.setLocalizedText(jLabel3, org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.jLabel3.text")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel1)
                    .add(jLabel2)
                    .add(jLabel3))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tfCurrentURL, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
                    .add(tfWorkingCopy, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
                    .add(tfNewURL, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(tfWorkingCopy, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(tfCurrentURL, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(tfNewURL, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel1.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.jLabel1.AccessibleContext.accessibleDescription")); // NOI18N
        tfWorkingCopy.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.tfWorkingCopy.AccessibleContext.accessibleName")); // NOI18N
        tfWorkingCopy.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.tfWorkingCopy.AccessibleContext.accessibleDescription")); // NOI18N
        jLabel2.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.jLabel2.AccessibleContext.accessibleDescription")); // NOI18N
        tfCurrentURL.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.tfCurrentURL.AccessibleContext.accessibleName")); // NOI18N
        tfCurrentURL.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.tfCurrentURL.AccessibleContext.accessibleDescription")); // NOI18N
        jLabel3.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.jLabel3.AccessibleContext.accessibleDescription")); // NOI18N
        tfNewURL.getAccessibleContext().setAccessibleName(org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.tfNewURL.AccessibleContext.accessibleName")); // NOI18N
        tfNewURL.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getMessage(RelocatePanel.class, "RelocatePanel.tfNewURL.AccessibleContext.accessibleDescription")); // NOI18N
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JTextField tfCurrentURL;
    private javax.swing.JTextField tfNewURL;
    private javax.swing.JTextField tfWorkingCopy;
    // End of variables declaration//GEN-END:variables
    
    public JTextField getWorkingCopy() {
        return tfWorkingCopy;
    }
    
    public JTextField getCurrentURL() {
        return tfCurrentURL;
    }
    
    public JTextField getNewURL() {
        return tfNewURL;
    }
}
