/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2010 Oracle and/or its affiliates. All rights reserved.
 *
 * Oracle and Java are registered trademarks of Oracle and/or its affiliates.
 * Other names may be trademarks of their respective owners.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.modules.xml.tools.java.generator;

import java.awt.event.*;
import java.beans.*;

/**
 * Should start a wizard traveling around panels.
 *
 * @author  pkuzel
 * @version
 */
public class SAXGeneratorCustomizer extends javax.swing.JPanel implements Customizer, ActionListener {

    /** Serial Version UID */
    private static final long serialVersionUID =9150516877346238338L;


    private SAXGeneratorModel model;
    private SAXGeneratorParsletPanel sAXGeneratorParsletPanel1;
    private SAXGeneratorMethodPanel sAXGeneratorMethodPanel1;
    private SAXGeneratorVersionPanel sAXGeneratorVersionPanel1;
    private SAXGeneratorFilePanel sAXGeneratorFilePanel1;

    /** Creates new form SAXGeneratorCustomizer */
    public SAXGeneratorCustomizer() {
        initComponents ();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setLayout(new java.awt.GridLayout(2, 2));
    }// </editor-fold>//GEN-END:initComponents

    public void setObject(java.lang.Object peer) {
        if ( not(peer instanceof SAXGeneratorModel) ) {
            throw new IllegalArgumentException("SAXGeneratorModel class expected.");  // NOI18N
        }        
        
        model = (SAXGeneratorModel) peer;
        
        sAXGeneratorParsletPanel1.setObject(model);
        sAXGeneratorMethodPanel1.setObject(model);  
        sAXGeneratorVersionPanel1.setObject(model);
        sAXGeneratorFilePanel1.setObject(model);
    }    

    private boolean not (boolean expr) {
        return ! expr;
    }
    
    public void addPropertyChangeListener(java.beans.PropertyChangeListener p1) {
    }
    
    public void removePropertyChangeListener(java.beans.PropertyChangeListener p1) {
    }
    
    public void actionPerformed(java.awt.event.ActionEvent e) {
        sAXGeneratorVersionPanel1.actionPerformed(e);
        sAXGeneratorFilePanel1.actionPerformed(e);

    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables

}
